//+------------------------------------------------------------------+
//|                                                       BBRSI3.mq4 |
//|                                   Copyleft  2010 Zakharov Vadim |
//|                                                   aka Yuritch    |
//+------------------------------------------------------------------+

// !         
//  Basketbull   8.6  !!!
#include <WinUser32.mqh>
#property  indicator_separate_window
#property indicator_buffers   1
#property indicator_color1    Orange
#property indicator_width1      2
#property indicator_levelcolor  Gray

//---- input parameters
int TF=0,period,basket,smooth,price,mode;
extern string  _=" ";
extern int     depth=1440;
extern double basket_overbought=67.0;
extern double basket_oversold=33.0;
int i, j;
double rsi[],rsima1[],rsima2[],delta[],delta1[],trend[],tmp,weight_sum,weight,trend_base;
string Pairs[];
bool Recalculate=true;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init() {
IndicatorDigits(0);
IndicatorBuffers(6);

      basket=GlobalVariableGet("num_pair");
      period=GlobalVariableGet("period");
      smooth=GlobalVariableGet("smooth");
      price= GlobalVariableGet("a_price");
      mode=GlobalVariableGet("mode");
      trend_base=GlobalVariableGet("trend_base");

      ArrayResize(Pairs,basket);

      SetIndexBuffer(0,trend);
      SetIndexStyle(0,DRAW_LINE);
      SetIndexLabel(0,"trend"); 
      SetIndexBuffer(1,delta1);
      SetIndexStyle(1,DRAW_NONE);
      SetIndexLabel(1,NULL);      
      SetIndexBuffer(2,delta);
      SetIndexStyle(2,DRAW_NONE);
      SetIndexLabel(2,NULL);      
      SetIndexBuffer(3,rsima1);
      SetIndexLabel(3,NULL);
      SetIndexStyle(3,DRAW_NONE);       
      SetIndexBuffer(4,rsima2);
      SetIndexLabel(4,NULL);
      SetIndexStyle(4,DRAW_NONE);       
      SetIndexBuffer(5,rsi);
      SetIndexLabel(5,NULL);       
      SetIndexStyle(5,DRAW_NONE);

      int pairs=FileOpen("bbpairs", FILE_CSV|FILE_READ);
   
      for (i=0;i<basket;i++)
         {
         if (FileIsEnding(pairs)) break;
         Pairs[i] = FileReadString(pairs);
         }
         FileClose(pairs);
         Recalculate=true;
return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit() 
{
   GlobalVariableDel("rsitrend");
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start() 
{
   int    limit;
   int counted_bars=IndicatorCounted();
   
   if ( counted_bars > 0 )  limit=Bars-counted_bars;
   if ( counted_bars < 0 )  return(0);
   if ( counted_bars ==0 ) limit=depth;
   if ( counted_bars < 1 )
      for(int i=1;i<depth+smooth+period;i++) 
         {
         rsi[Bars-i]=0;    
         rsima1[Bars-i]=0;  
         rsima2[Bars-i]=0;    
         delta[Bars-i]=0;  
         delta1[Bars-i]=0;    
         } 
   
   if (GlobalVariableGet("reset") !=0)
      {
       Recalculate=true;
       IndicatorShortName("  ");
       return(0);
      }
   else  IndicatorShortName("BBRSI3("+period+","+smooth+","+mode+","+price+")");

   if (Recalculate)
      {
      basket=GlobalVariableGet("num_pair");
      period=GlobalVariableGet("period");
      smooth=GlobalVariableGet("smooth");
      price= GlobalVariableGet("a_price");
      mode=GlobalVariableGet("mode");
      trend_base=GlobalVariableGet("trend_base");

      ArrayResize(Pairs,basket);
    
      for(i=1;i<depth+smooth+period;i++) 
         {
         rsi[Bars-i]=0;    
         rsima1[Bars-i]=0;  
         rsima2[Bars-i]=0;    
         delta[Bars-i]=0;  
         delta1[Bars-i]=0;    
         }     
                        
      int pairs=FileOpen("bbpairs", FILE_CSV|FILE_READ);
   
      for (i=0;i<basket;i++)
         {
         if (FileIsEnding(pairs)) break;
         Pairs[i] = FileReadString(pairs);
         }
      FileClose(pairs);
      
      SetLevelValue(1,1);
      SetLevelValue(2,-1);
      SetLevelValue(3,2);
      SetLevelValue(4,-2);
      limit=depth;      
      }

   
   i=limit;
   while(i >= 0) 
      {
      tmp = 0.0;
      for(j = 0; j < basket; j++) 
         {
         if (StringLen(Pairs[j])==0) continue;
         tmp = tmp + iRSI(Pairs[j],TF,period,price,i);
         }
      rsi[i] = tmp/basket;
      i--;
      }
   ArraySetAsSeries(rsi,true);
     
   i=limit;
   while(i >= 0)   
      {
      rsima1[i]=iMAOnArray(rsi,0,smooth,0,mode,i);
      rsima2[i]=iMAOnArray(rsi,0,MathRound(smooth/2),0,mode,i);
      i--;
      }
  
   i=limit;
   while(i >= 0)
      {
      delta[i]=NormalizeDouble(rsima2[i]-rsima1[i],1);
      if ((delta[i]>0 && delta[i]>delta1[i+1]) || (delta[i]<0 && delta[i]<delta1[i+1])) 
         {
         delta1[i]=delta[i];
         }
      else delta1[i]=delta1[i+1];
         
      trend[i]=0;

      if ((delta1[i]<0 && delta1[i]==delta1[i+1] && delta[i]>delta[i+1]) || (delta[i]>0 && delta[i]>delta[i+1])) 
         {
         trend[i]= 1;
         }
      if ((delta1[i]>0 && delta1[i]==delta1[i+1] && delta[i]<delta[i+1]) || (delta[i]<0 && delta[i]<delta1[i+1])) 
         {
         trend[i]=-1;
         }
      if (delta1[i]==delta1[i+1] && delta[i]==delta1[i+1]) trend[i]=0;
      
      if (rsima2[i]>=basket_overbought) trend[i]= 2;
      if (rsima2[i]<=basket_oversold) trend[i]=-2;
      
      i--;
      }
      
   GlobalVariableSet("rsitrend",trend[0]);
      
   if (Recalculate==true) {WindowRedraw();Recalculate=false;}
return(0);
}

